<?php
/*
* (c) Copyright: Ninjoomla, www.ninjoomla.com - Code so sharp, it hurts.
* email: phlux0r@gmail.com
* date: 7 September, 2007
* Release: 1.0
* PHP Code License : http://www.gnu.org/copyleft/gpl.html GNU/GPL
* JavaScript Code & CSS  : Ninjoomla License - http://www.ninjoomla.com
*
* Changelog
*
* 1.0 Oct 15, 07 :
*       Initial Version
*
*/
###################################################################
//Joomla 1.0.13 Admin Logout Bug Patcher Component
//Copyright (C) 2007 Robert Popovic. Ninjoomla.com. All rights reserved.
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
###################################################################

// Dont allow direct linking
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

function com_install()
{
?>
<h3 align="center">Joomla 1.0.13 Admin Logout Bug Patcher Component v1.0</h3>
<a href="http://www.ninjoomla.com" target="_self"><img src="components/com_al_patch/box_al_patch_sml.jpg" alt="Visit Ninjoomla" title="Visit Ninjoomla" style="border:none;"/></a>
	<p>&copy; Copyright 2007 Robert Popovic. Ninjoomla.com. All rights reserved.</p>
	<p>For questions and support please go to <a href="http://www.ninjoomla.com">http://www.ninjoomla.com</a>.</p>
<?php
	// We'll collect all the messages and return it to the calling function so we get a nice report when the installer finishes.
	// Go for life...
	$msg = "<h4>Verifying patch conditions...</h4>";
	$files = array(array("/administrator/","index.php", "/administrator/components/com_al_patch/index.patch"),array("/includes/","joomla.php","/administrator/components/com_al_patch/joomla.patch"));
	if (!verifyVersion($msg)) {
		$msg .= "<p><strong>We've discovered problems with your Joomla version. Please make sure that you are applying this patch on a Joomla 1.0.13 installation only!</strong></p>
		<p><strong>You may safely uninstall this component</strong></p>";
		return $msg;
	}
	if (!verify3rdPartyHacks($msg)) {
		$msg .= "<p><strong>We've discovered problems while verifying the conditions for this patch. If you have any 3RD party components installed that have modified the files for this patch you will have to apply this patch manually.</strong></p>
		<p><strong>You may safely uninstall this component</strong></p>";
		return $msg;
	}
	if (!verifyFiles($files,$msg)) {
		$msg .= "<p><strong>We've discovered problems while verifying the files to be patched. Please make sure that the files are writable by the system and try again.</strong></p>
		<p>To try again, uninstall this component and re-install it after correcting the problem.</p>";
		return $msg;
	}
	$msg .= "<h4>Applying patch...</h4>";
	if (!applyPatch($files,$msg)) {
		$msg .= "<p><strong>There were problems while applying the patch. Please make sure that the directories and files exist and are writable by the system and try again.</strong></p>
		<p>To try again, uninstall this component and re-install it after correcting the problem.</p>";
		return $msg;
	}
	$msg .= "<h4>Verifying patch...</h4>";

	if (!verifyPatch($files,$msg)) {
		$msg .= "<p><strong>We've discovered problems while verifying the patch. Please restore the original files from the created backups to restore your site.</strong></p>
		<p>To try again, uninstall this component and re-install it after correcting the problem.</p>";
		return $msg;
	}
	// all is well
	$msg .= "<h4>Congratulations, the patch has been applied successfully and your original files have been backed up.</h4>
		<p><strong>You may safely uninstall this component. The patched files and backups will be kept.</strong></p>";
	return $msg;
}
/**
 * Checks the Joomla version
 *
 * @param unknown_type $msg
 * @return unknown
 */
function verifyVersion(&$msg) {
	global $_VERSION;
	$version = $_VERSION->getShortVersion();
	if ($version != '1.0.13') {
		$msg .= '<p><strong style="color:red;">This patch is only for Joomla! v1.0.13.</strong></p>';
		return false;
	}
	return true;
}
/**
 * Checks if 3rd party hacks installed (AEC and JACLPlus)
 *
 * @param unknown_type $msg
 * @return unknown
 */
function verify3rdPartyHacks(&$msg) {
	global $mosConfig_absolute_path;
	$ret = true;
	// check for AEC & JACLPlus
	if (file_exists($mosConfig_absolute_path.'/administrator/components/com_acctexp')){
		$msg .= '<span style="color:red;"><strong>You have AEC installed on your system, this component has already modified one or more of the files we are attempting to patch. You will have to apply this patch manually.</strong></span><br/>';
		$ret = false;
	}
	if (file_exists($mosConfig_absolute_path.'/administrator/components/com_jaclplus')){
		$msg .= '<span style="color:red;"><strong>You have JACLPlus installed on your system, this component has already modified one or more of the files we are attempting to patch. You will have to apply this patch manually.</strong></span><br/>';
		$ret = false;
	}
	if (file_exists($mosConfig_absolute_path.'/administrator/components/com_jhax')){
		$msg .= '<span style="color:red;"><strong>You have JHax installed on your system, this component *may have* already modified one or more of the files we are attempting to patch. You will have to apply this patch manually.</strong></span><br/>';
		$ret = false;
	}
	return $ret;
}
/**
 * Verify the directories and files for writability
 *
 * @param unknown_type $files
 * @param unknown_type $msg
 * @return unknown
 */
function verifyFiles(&$files, &$msg) {
	global $mosConfig_absolute_path;
	$ret = true;

	foreach ($files as $file) {
		$patchDir = $mosConfig_absolute_path.$file[0];
		$patchFile = $patchDir.$file[1];
		// dir
		$msg .= "<strong>Directory containing files to be patched:</strong> ".$patchDir." - ";
		if (file_exists($patchDir) && is_writeable($patchDir)) {
			$msg .= '<span style="color:green;">is writable</span><br/>';
		} else {
			$msg .= '<span style="color:red;">is not writable</span><br/>';
			$ret = false;
		}
		// files
		$msg .= "<strong>File to be patched:</strong> ".$patchFile." - ";
		// try to find the file to hack and see if it can be written to
		if (file_exists($patchFile) && is_writeable($patchFile)) {
			$msg .= '<span style="color:green;">can be patched</span><br/>';
		} else {
			$msg .= '<span style="color:red;">is not writable</span><br/>';
			$ret = false;
		}
	}
	return $ret;
}
/**
 * Apply the patch and back up the files
 *
 * @param unknown_type $files
 * @param unknown_type $msg
 * @return unknown
 */
function applyPatch(&$files, &$msg) {
	global $mosConfig_absolute_path;
	$backupExt = ".al.bak";
	$ret = true;
	foreach ($files as $file) {
		$patchFile = $mosConfig_absolute_path.$file[0].$file[1];
		$patcher = $mosConfig_absolute_path.$file[2];
		$msg .= "<strong>File:</strong> ".$patchFile." - ";
		// make backup
		if (!rename($patchFile, $patchFile.$backupExt)) {
			$msg .= '<span style="color:red;">could not create backup</span><br/>';
			$ret = false;
		} else if (!copy($patcher, $patchFile)) {
			$msg .= '<span style="color:red;">could not copy patch file: '.$patcher.'</span><br/>';
			$ret = false;
			if (!rename($patchFile.$backupExt, $patchFile)) {
				$msg .= '<span style="color:red;">...could not restore backup</span><br/>';
			} else {
				$msg .= '<span style="color:green;">...restored original file from backup</span><br/>';
			}
		} else {
			$msg .= '<span style="color:green;">successfully patched</span><br/>';
		}
	}
	return $ret;
}
/**
 * Verify the result by checking if the files are there
 *
 * @param unknown_type $files
 * @param unknown_type $msg
 * @return unknown
 */
function verifyPatch(&$files, &$msg) {
	global $mosConfig_absolute_path;
	$ret = true;
	foreach ($files as $file) {
		$patchFile = $mosConfig_absolute_path.$file[0].$file[1];
		$msg .= "<strong>Patched file:</strong> ".$patchFile." - ";
		// try to find the file to hack and see if it can be written to
		if (file_exists($patchFile)) {
			$msg .= '<span style="color:green;">OK</span><br/>';
		} else {
			$msg .= '<span style="color:red;">does not exists!</span><br/>';
			$ret = false;
		}
	}
	return $ret;
}
?>
