<?php
/**
*  Mambot that creates content teaser boxes throughout the content, where specified.
*
* @author:  Robert Popovic - www.ninjoomla.com
* @date:    August 2007
* @version: 1.1
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*
* <b>Usage:</b>
* {conteaser[ quotes={0|1}[;class="<css_class>"[;<layer_style>:<style_value>;...]]]}...teaser text...{/conteaser}
*
* you may specify no parameters at all - in that case the default style will be used which is a box with
* white background, font size 12px, 1px black solid border, right aligned.
* 
* you may specify only one quotes parameter. The default value is 1 - quotes are displayed
* you may specify only one class parameter
* you may specify 0,1 or many additional layer style parameter in the form <layer_style>:<style_value>;.
* i.e. float:right;width:130px; etc... styles specified in the parameters override styles from the css class
* it is recommended to use layer positioning of relative!
* 
* The minimum set of layer styles implemented either in a class or passed as parameters should be as follows
* (values are only used as an example except the relative positioning):
*	position: relative;
*	border: 1px solid #000000;
*	width: 140px;
*	overflow: visible;
*	float: right;
*/
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$_MAMBOTS->registerFunction( 'onPrepareContent', 'bot_con_teaser' );

function bot_con_teaser( $published, &$row, $mask=0, $page=0 ) {

	if(!$published) {
		return true;
	}

	$defaultStyle = 'style="float:right;margin:0 0 0 5px;width:140px;background-color:#fff;padding:3px;border:1px solid #000;position:relative;"';

	preg_match_all( "/{(conteaser)\s*(.*?)}(.*?){\/conteaser}/im", $row->text, $bots, PREG_SET_ORDER );
	$text = preg_split( "/{(conteaser)\s*(.*?)}(.*?){\/conteaser}/im", $row->text );
	$n = count( $text );

	if ($n > 1) {
		$row->text = '';
		$showqotes = 1;
		$divAttributes = '';
		$styles = '';
		for ($i=0; $i<$n; $i++) {
			$row->text .= $text[$i];
			if (isset($bots[$i])) {
				$params = explode(';', $bots[$i][2]);
				if ($params[0]) {
					$m = count($params);
					for ($j=0; $j<$m; $j++) {
						if (strpos($params[$j], 'quotes') === 0) {
							$quotesArr = explode('=', $params[$j]);
							$showqotes = $quotesArr[1];
						} elseif (strpos($params[$j], 'class') === 0) {
							$divAttributes .= $params[$j];
						} else  {
							$styles .= $params[$j] . ';';
						}
					}
					if ($styles) {
						$divAttributes .= ' style="' . $styles . '"';
					}
				}
				$div = '<div ' . ($divAttributes?$divAttributes:$defaultStyle) . '>';
				if ($showqotes == 1) {
					$openquotes = '<span id="ct_openquote">&ldquo;</span>';
					$closequotes = '<span id="ct_closequote">&rdquo;</span>';
					$row->text .= $div . $openquotes . $bots[$i][3] .$closequotes . '</div>';
				} else {
					$row->text .= $div . $bots[$i][3] . '</div>';
				}
			}
		}
	}
}
?>
